<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('_JEXEC') or die();

jimport('joomla.application.component.view');
class CobaltViewComment extends JViewLegacy
{

	protected $state;

	protected $item;

	protected $form;

	/**
	 * Display the view
	 */
	public function display($tpl = null)
	{
		$this->state = $this->get('State');
		$this->item = $this->get('Item');
		$this->form = $this->get('Form');
		
		// Check for errors.
		if(count($errors = $this->get('Errors')))
		{
			JError::raiseError(500, implode("\n", $errors));
			return false;
		}
		
		$this->addToolbar();
		parent::display($tpl);
	}

	/**
	 * Add the page title and toolbar.
	 *
	 * @since	1.6
	 */
	protected function addToolbar()
	{
		JFactory::getApplication()->input->set('hidemainmenu', true);
		
		$user		= JFactory::getUser();
		$isNew		= ($this->item->id == 0);
		
		JToolBarHelper::title(JText::_('CEDITCOMMENT'), 'comments.png');
		
		JToolBarHelper::apply('comment.apply', 'JTOOLBAR_APPLY');
		JToolBarHelper::save('comment.save', 'JTOOLBAR_SAVE');
		
		JToolBarHelper::cancel('comment.cancel', 'JTOOLBAR_CANCEL');
		//MRToolBar::helpW('http://help.mintjoomla.com/cobalt/index.html?filters.htm', 1000, 500);
		JToolBarHelper::divider();
	}
}